/*********************************************************
 *
 *    defunc demonstration example 
 *
 *    Author: Ke Jin, Queen's U. Canada
 *
 *    to compile: cc demo.c -ldfc -lm -o demo
 *
 *********************************************************/
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <defunc.h>

int main()
{
    double (*fp)();
    char expr[128];
    double x, a, b;

    matha2z(); /* portable functions in  math lib into token table */

    printf("\n\tEnter a expression please(\"quit\" or \"exit\" to exit).\n");

    for(;;)
    {
       printf("\n\tinput > ");
       fgets(expr, 127, stdin);
       expr[strlen(expr)-1]='\0';   /* strip off the '\n' on end */

       if(strncmp(expr, "quit", 4)==0||
	  strncmp(expr, "exit", 4)==0)
       {
           printf("\n\t\t--------- Bye! ---------\n\n");
	   return 0;
       }

       fp = dfopen(expr);
       a=dfcmin(1);
       b=dfcmax(1);
       if(a==0.0&&b==0.0) b=1.0; 

       if(fp==0)  
       {
	   printf("\t\t%s\n", dferror()); 
	   printf("\n\t\tcurrent arguments are %s, %s\n",
	       getarguname(1), getarguname(2));
           printf("\t\tx in [%.3g,%.3g]\n\t\ty in [%.3g,%.3g]\n",
	       dfcmin(1), dfcmax(1), dfcmin(2), dfcmax(2));

	   continue;
       }
       else 
       {
           printf("\t\t%s\t\t%s\n", getarguname(1), getexprbody(expr));
           for(x=a;x<b;x=x+0.1*(b-a))
           {
	       printf("\t\t%f\t%f\n", x, fp(x,0));
           }
       }

       printf("\n\t\tcurrent arguments are %s, %s\n", 
               getarguname(1), getarguname(2));
       printf("\t\tx in [%.3g,%.3g]\n\t\ty in [%.3g,%.3g]\n", 
                  dfcmin(1), dfcmax(1), dfcmin(2), dfcmax(2));

       dfclose(fp);
    }
}
